<?php

class DataArr_Teachers {

    protected $model;
    
    public function __construct() {
        $this->model = new Model_DataArr_Teachers;
    }
    
    public function byFaculty($facultyID)
    {
        if($facultyID != 0)
        {
            $teachers = $this->model->getTeachersByFaculty($facultyID);
            $i = 0;
            foreach($teachers as $row)
            {
                $i++;
                $teachersHandled[$i]['ID'] = $row['TeacherID'];
                $teachersHandled[$i]['AccountID'] = $row['TeacherAccID'];
                $teachersHandled[$i]['FirstName'] = $row['TeacherFirst'];
                $teachersHandled[$i]['SecondName'] = $row['TeacherSecond'];
                $teachersHandled[$i]['LastName'] = $row['TeacherLast'];
                $teachersHandled[$i]['JobPositionName'] = $row['JobPositionName'];
                $teachersHandled[$i]['DepartmentID'] = $row['DepID'];
                $teachersHandled[$i]['DepartmentName'] = $row['DepName'];
            }                
        }
        return new DataArray_Result($teachersHandled);
    }
    
    public function byDepartment($departmentID)
    {
        $teachers = $this->model->getTeachersByDepartment($departmentID);
        $i = 0;
        foreach($teachers as $row)
        {
            $i++;
            $teachersHandled[$i]['ID'] = $row['TeacherID'];
            $teachersHandled[$i]['AccountID'] = $row['TeacherAccID'];
            $teachersHandled[$i]['FirstName'] = $row['TeacherFirst'];
            $teachersHandled[$i]['SecondName'] = $row['TeacherSecond'];
            $teachersHandled[$i]['LastName'] = $row['TeacherLast'];
            $teachersHandled[$i]['JobPositionName'] = $row['JobPositionName'];
            $teachersHandled[$i]['DepartmentName'] = $row['DepName'];
        }
        return new DataArray_Result($teachersHandled);
    }
    
    public function forDiscipline($disciplineID, $asConcat = false, $asInitials = false)
    {
        $teachers = $this->model->getTeachersForDiscipline($disciplineID);
        $teachersHandled = array(); $i = 0;
        foreach ($teachers as $teacher)
        {
            $i++; $tchr = array();
            $tchr['isAuthor'] = $teacher['isAuthor'];
            $tchr['TeacherID'] = $teacher['TeacherID'];
            $tchr['LastName'] = $teacher['TeacherLast'];
            $tchr['FirstName'] = $asInitials ? 
                    UTF8::substr($teacher['TeacherFirst'], 0, 1).'. ' : $teacher['TeacherFirst'];
            if(!empty($teacher['TeacherSecond']))
            $tchr['SecondName'] = $asInitials ? 
                    UTF8::substr($teacher['TeacherSecond'], 0, 1).'. ' : $teacher['TeacherSecond'];
            if($asConcat)
                $teachersHandled[$i] = $tchr['LastName'].$tchr['FirstName'].$tchr['SecondName'];
            else
                $teachersHandled[$i] = $tchr;
        }
        return new DataArray_Result($teachersHandled);
    }
    
}
